/*
* Copyright (c) 2017 Calvin Rose
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*/

#ifndef DST_MATH_H_defined
#define DST_MATH_H_defined

#include "dsttypes.h"

int dst_add(int32_t argn, DstValue *argv, DstValue *ret);
int dst_subtract(int32_t argn, DstValue *argv, DstValue *ret);
int dst_multiply(int32_t argn, DstValue *argv, DstValue *ret);
int dst_divide(int32_t argn, DstValue *argv, DstValue *ret);
int dst_modulo(int32_t argn, DstValue *argv, DstValue *ret);

int dst_acos(int32_t argn, DstValue *argv, DstValue *ret);
int dst_asin(int32_t argn, DstValue *argv, DstValue *ret);
int dst_atan(int32_t argn, DstValue *argv, DstValue *ret);
int dst_cos(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_cosh(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_sin(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_sinh(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_tan(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_tanh(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_exp(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_log(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_log10(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_sqrt(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_ceil(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_fabs(int32_t argn, DstValue *argv, DstValue *ret); 
int dst_floor(int32_t argn, DstValue *argv, DstValue *ret); 

int dst_stl_table(int32_t argn, DstValue *argv, DstValue *ret);
int dst_stl_array(int32_t argn, DstValue *argv, DstValue *ret);
int dst_stl_struct(int32_t argn, DstValue *argv, DstValue *ret);
int dst_stl_tuple(int32_t argn, DstValue *argv, DstValue *ret);

#endif /* DST_MATH_H_defined */
